nx_server_plugin_sdk 1.0 Server Plugin SDK

Classes | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
nx::sdk::analytics::IAction Class Referenceabstract

`#include <i_action.h>`

Inheritance diagram for nx::sdk::analytics::IAction:

## Classes
struct | Result

## Public Member Functions
virtual const char * | actionId () const =0
Uuid | objectTrackId () const
Uuid | deviceId () const
Ptr< IObjectTrackInfo > | objectTrackInfo () const
virtual int64_t | timestampUs () const =0
Ptr< const IStringMap > | params () const
Public Member Functions inherited from nx::sdk::Interface< IAction >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IRefCountable
virtual | ~IRefCountable ()=default
template<class Interface >
Ptr< Interface > | queryInterface ()
template<class Interface >
Ptr< const Interface > | queryInterface () const
virtual int | addRef () const =0
virtual int | releaseRef () const =0
int | refCountThreadUnsafe () const

## Static Public Member Functions
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IRefCountable
static auto | interfaceId ()

## Protected Member Functions
virtual void | getObjectTrackId (Uuid *outValue) const =0
virtual void | getDeviceId (Uuid *outValue) const =0
virtual IObjectTrackInfo * | getObjectTrackInfo () const =0
virtual const IStringMap * | getParams () const =0
Protected Member Functions inherited from nx::sdk::Interface< IAction >
virtual IRefCountable * | queryInterface (const IRefCountable::InterfaceId *id) override
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)

## Additional Inherited Members
Static Protected Member Functions inherited from nx::sdk::IRefCountable
template<int len>
static const InterfaceId * | makeId (const char(&charArray)[len])
template<int len, int alternativeLen>
static std::vector< const InterfaceId * > | makeIdWithAlternative (const char(&charArray)[len], const char(&alternativeCharArray)[alternativeLen])
template<class TemplateInstance , class TemplateArg , int len>
static const InterfaceId * | makeIdForTemplate (const char(&baseIdCharArray)[len])
static std::vector< const InterfaceId * > | alternativeInterfaceIds (const InterfaceId *id)
static std::vector< const InterfaceId * > | alternativeInterfaceIds (std::vector< const InterfaceId *> ids)

## Detailed Description

Data supplied to IEngine::executeAction().

## Member Function Documentation

## ◆ actionId()

virtual const char* nx::sdk::analytics::IAction::actionId | ( |  | ) | const
| pure virtual

Id of the action being triggered.

## ◆ deviceId()

Uuid nx::sdk::analytics::IAction::deviceId | ( |  | ) | const
| inline

Id of a device from which the action has been triggered.

## ◆ getDeviceId()

virtual void nx::sdk::analytics::IAction::getDeviceId | ( | Uuid * | outValue | ) | const
| protectedpure virtual

Called by deviceId()

## ◆ getObjectTrackId()

virtual void nx::sdk::analytics::IAction::getObjectTrackId | ( | Uuid * | outValue | ) | const
| protectedpure virtual

Called by objectTrackId()

## ◆ getObjectTrackInfo()

virtual IObjectTrackInfo* nx::sdk::analytics::IAction::getObjectTrackInfo | ( |  | ) | const
| protectedpure virtual

Called by objectTrackInfo()

## ◆ getParams()

virtual const IStringMap* nx::sdk::analytics::IAction::getParams | ( |  | ) | const
| protectedpure virtual

Called by params()

## ◆ objectTrackId()

Uuid nx::sdk::analytics::IAction::objectTrackId | ( |  | ) | const
| inline

Id of an object track for which the action has been triggered.

## ◆ objectTrackInfo()

Ptr<IObjectTrackInfo> nx::sdk::analytics::IAction::objectTrackInfo | ( |  | ) | const
| inline

Info about an object track this action has been triggered for.

## ◆ params()

Ptr<const IStringMap> nx::sdk::analytics::IAction::params | ( |  | ) | const
| inline

If the Engine manifest defines params for this action type, contains the array of their values after they are filled by the user via Client form. Otherwise, null.

## ◆ timestampUs()

virtual int64_t nx::sdk::analytics::IAction::timestampUs | ( |  | ) | const
| pure virtual

Timestamp of a video frame from which the action has been triggered.

The documentation for this class was generated from the following file:

- src/nx/sdk/analytics/i_action.h